import { Drink } from '../store';

function filter(
  rows: Array<Drink>,
  terms: { value: string; key: string },
  cols: Array<{ name: string; label: string; field: string }>,
  cellValue: { (col: { name: string; label: string; field: string }, row: Drink): string }
) {
  if (terms.value) {
    return rows.filter((row) => {
      if (!terms.key || terms.key === '') {
        return cols.some((col) => {
          const val = cellValue(col, row) + '';
          const haystack = val === 'undefined' || val === 'null' ? '' : val.toLowerCase();
          return haystack.indexOf(terms.value) !== -1;
        });
      }
      const index = cols.findIndex((col) => col.name === terms.key);
      const val = cellValue(cols[index], row) + '';
      const haystack = val === 'undefined' || val === 'null' ? '' : val.toLowerCase();
      return haystack.indexOf(terms.value) !== -1;
    });
  }
  return rows;
}

export { filter };
